## cpu-x 5.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
# https://cmake.org/cmake/help/latest/policy/CMP0177.html
if(POLICY CMP0177)
	cmake_policy(SET CMP0177 NEW)
endif()
project(cpu-x
	VERSION "5.4.0"
	LANGUAGES C CXX
)

# Check for x86 CPU
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")
	set(CPU_ISA_X86 TRUE)
else()
	set(CPU_ISA_X86 FALSE)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$|(x86)|(X86)|(amd64)|(AMD64)")

# Check for ARM CPU
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")
	set(CPU_ISA_ARM TRUE)
else()
	set(CPU_ISA_ARM FALSE)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv.*|aarch64")

# Check if platform is supported
if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
	message(WARNING "'${CMAKE_SYSTEM_NAME}' system is not officially supported by CPU-X, some features will not be available.")
endif(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD")
if(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)
	message(WARNING "'${CMAKE_SYSTEM_PROCESSOR}' processor is not officially supported by CPU-X, some features will not be available.")
endif(NOT CPU_ISA_X86 AND NOT CPU_ISA_ARM)


### DEFAULT CONFIG

# Global variables
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(GNUInstallDirs)
# Avoid to put files under /usr/libexec or /usr/local/libexec on Linux when the path does not exist
# On FreeBSD, /usr/local/libexec is missing under Poudriere (https://gitlab.com/FreeBSD/freebsd-ports/-/commit/eb6c9c8c4aa5981078c6b9b69527ecdaee5f22c9)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
	set(CMAKE_INSTALL_LIBEXECDIR      lib/${CMAKE_PROJECT_NAME})
	set(CMAKE_INSTALL_FULL_LIBEXECDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR})
endif(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/bin/)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/lib/)
set(CMAKE_DATA_OUTPUT_DIRECTORY    ${CMAKE_BINARY_DIR}/output/data/)
set(CPU_X_DATA_DIRECTORY           ${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}/)
set(APP_EXEC                       ${CMAKE_PROJECT_NAME})
set(DAEMON_EXEC                    ${CMAKE_PROJECT_NAME}-daemon)
set(DAEMON_PATH                    ${CMAKE_INSTALL_FULL_LIBEXECDIR}/${DAEMON_EXEC})
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(DAEMON_SOCKET              "/run/cpu-x.sock")
else()
	set(DAEMON_SOCKET              "/var/run/cpu-x.sock")
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")
set(CMAKE_COLOR_DIAGNOSTICS ON)
set(CMAKE_C_FLAGS             "${CMAKE_C_FLAGS} -Wno-unused-result")
set(CMAKE_CXX_FLAGS           "${CMAKE_CXX_FLAGS} -Wpedantic -Wno-unused-result -Wno-psabi")
set(CMAKE_C_FLAGS_DEBUG       "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security -Wstrict-prototypes")
set(CMAKE_CXX_FLAGS_DEBUG     "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Wuninitialized -Wformat -Wformat-security")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
set(CMAKE_EXE_LINKER_FLAGS    "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")

include(CheckCCompilerFlag)
check_c_compiler_flag("-no-pie" HAS_NO_PIE)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND HAS_NO_PIE)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -no-pie")
endif(CMAKE_SYSTEM_NAME MATCHES "Linux" AND HAS_NO_PIE)

# Options
option(WITH_GTK           "Build support for GUI in GTK3+"                                    ON)
option(WITH_NCURSES       "Build support for TUI in NCurses"                                  ON)
option(WITH_GETTEXT       "Build support for internationalization"                            ON)
option(WITH_LIBCPUID      "Use Libcpuid library"                                              ON)
option(WITH_LIBPCI        "Use Libpci library"                                                ON)
option(WITH_LIBEGL        "Use Libegl library"                                                ON)
option(WITH_VULKAN        "Use Vulkan library"                                                ON)
option(WITH_OPENCL        "Use OpenCL library"                                                ON)
option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
if(CPU_ISA_X86)
	option(WITH_BANDWIDTH "Built-in Bandwidth"                                                ON) # Bandwidth is only supported on x86 CPUs (requires cache size)
else()
	set(WITH_BANDWIDTH OFF)
endif(CPU_ISA_X86)
option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
option(APPIMAGE           "Enable workarounds for AppImage"                                   OFF)
option(FLATPAK            "Enable workarounds for Flatpak"                                    OFF)

# Colours
string(ASCII 27 Esc)
set(ColourReset "${Esc}[m")
set(ColourBold  "${Esc}[1m")
set(Red         "${Esc}[31m")
set(Green       "${Esc}[32m")
set(Yellow      "${Esc}[33m")
set(Blue        "${Esc}[34m")
set(Magenta     "${Esc}[35m")
set(Cyan        "${Esc}[36m")
set(White       "${Esc}[37m")
set(BoldRed     "${Esc}[1;31m")
set(BoldGreen   "${Esc}[1;32m")
set(BoldYellow  "${Esc}[1;33m")
set(BoldBlue    "${Esc}[1;34m")
set(BoldMagenta "${Esc}[1;35m")
set(BoldCyan    "${Esc}[1;36m")
set(BoldWhite   "${Esc}[1;37m")


### FUNCTIONS

# Credits to jtanx: https://gist.github.com/jtanx/96ded5e050d5ee5b19804195ee5cf5f9
# Function: pad_string(output str padchar length)
# Add padding to a string
# @output:  variable name for output string
# @str:     input string
# @padchar: character used for padding
# @length:  padding length
function(pad_string output str padchar length)
	string(LENGTH "${str}" _strlen)
	math(EXPR _strlen "${length} - ${_strlen}")
	if(_strlen GREATER 0)
		if(${CMAKE_VERSION} VERSION_LESS "3.14")
			unset(_pad)
			foreach(_i RANGE 1 ${_strlen}) # inclusive
				string(APPEND _pad ${padchar})
			endforeach()
		else()
			string(REPEAT ${padchar} ${_strlen} _pad)
		endif()
		string(APPEND str ${_pad})
	endif()
	set(${output} "${str}" PARENT_SCOPE)
endfunction()


### MACROS

# Macro: print_config(libname libver withstate)
# Print the state of CPU-X features: in bold green if enabled, else bold red.
# @libname:    library name (e.g. GTK)
# @libver:     library version (e.g. XXXXX_VERSION)
# @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
macro(print_config libname libver withstate)
	pad_string(lib_string ${libname} " " 15)
	if(${withstate})
		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset} (version is ${libver})")
		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
	else(${withstate})
		message("${BoldCyan}**   ${lib_string}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset}")
		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
	endif(${withstate})
endmacro(print_config)


### HELPERS / SUBDIRECTORIES

set(GIT_REVISION "")
if(DEFINED ENV{GITHUB_SHA})
	set(GIT_REVISION "+git-$ENV{GITHUB_SHA}")
elseif(EXISTS ${CMAKE_SOURCE_DIR}/.git)
	find_package(Git)
	if(GIT_FOUND)
		execute_process(COMMAND sh -c "${GIT_EXECUTABLE} describe --long --tags --exclude continuous --abbrev=40 --dirty | cut --delimiter=- --fields=2-"
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
			OUTPUT_VARIABLE GIT_DESCRIBE_REVISION
			ERROR_QUIET
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
		if(GIT_DESCRIBE_REVISION STREQUAL "")
			message(WARNING "Unknown Git revision.")
		else(GIT_DESCRIBE_REVISION STREQUAL "")
			set(GIT_REVISION "+git-r${GIT_DESCRIBE_REVISION}")
		endif(GIT_DESCRIBE_REVISION STREQUAL "")
	else(GIT_FOUND)
		message(WARNING "Git package not found, GIT_REVISION cannot be set.")
	endif(GIT_FOUND)
endif()

enable_testing()
find_package(PkgConfig REQUIRED)
find_package(Threads REQUIRED)
find_package(Backtrace REQUIRED)
find_package(Filesystem REQUIRED)
if(WITH_GETTEXT)
	find_package(Gettext REQUIRED)
	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
		find_package(Intl REQUIRED)
	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
endif(WITH_GETTEXT)
#include(CheckSymbolExists)
#include(CheckStructHasMember)
#include(CheckCSourceCompiles)
include(CheckCSourceRuns)
#include(CheckIncludeFile)
include(CheckLanguage)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)


### UNINSTALL TARGET

configure_file("${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== data/CMakeLists.txt ===
project(data
	LANGUAGES NONE
)


add_subdirectory(completions)

# Files needed by GTK GUI
if(WITH_GTK)
	include(GSettings)

	# Set config
	file(MAKE_DIRECTORY ${CMAKE_DATA_OUTPUT_DIRECTORY})
	if(GETTEXT_FOUND)
		set(TMP_DESKTOP_FILE_FILENAME    "${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop.in")
		set(OUTPUT_DESKTOP_FILE_FILENAME "${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop")
		add_custom_command(
			OUTPUT "${OUTPUT_DESKTOP_FILE_FILENAME}"
			DEPENDS "${TMP_DESKTOP_FILE_FILENAME}"
			COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
				--desktop
				--template="${TMP_DESKTOP_FILE_FILENAME}"
				-d "${CMAKE_SOURCE_DIR}/po"
				--output-file="${OUTPUT_DESKTOP_FILE_FILENAME}"
		)
		add_custom_target (
			gendesktop ALL DEPENDS
			"${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop"
		)
	else()
		set(TMP_DESKTOP_FILE_FILENAME "${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop")
	endif(GETTEXT_FOUND)
	configure_file(io.github.thetumultuousunicornofdarkness.cpu-x.desktop.in       ${TMP_DESKTOP_FILE_FILENAME})
	configure_file(io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy.in ${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy)

	# Install UIs
	install(FILES
		cpu-x-gtk-3.12.ui
		cpu-x-gtk-3.12.css
		cpu-x-gtk-3.12-dark.css
		cpu-x-gtk-3.20.css
		cpu-x-gtk-3.20-dark.css
		DESTINATION ${CPU_X_DATA_DIRECTORY}/
	)

	# AppData metainfo file
	install(FILES
		io.github.thetumultuousunicornofdarkness.cpu-x.appdata.xml
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo/
	)

	# Install launcher
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x.desktop
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications/
	)

	# Install policy rule
	pkg_get_variable(POLKIT_ACTION_DIR polkit-gobject-1 actiondir)
	if(POLKIT_ACTION_DIR STREQUAL "")
		set(POLKIT_ACTION_DIR "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/")
	endif(POLKIT_ACTION_DIR STREQUAL "")
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/io.github.thetumultuousunicornofdarkness.cpu-x-daemon.policy
		DESTINATION ${POLKIT_ACTION_DIR}
	)

	# Install schema file
	add_schema("io.github.thetumultuousunicornofdarkness.cpu-x.gschema.xml")

	add_subdirectory(icons)
	add_subdirectory(logos)
endif(WITH_GTK)

=== po/CMakeLists.txt ===
project(po
	LANGUAGES NONE
)


### INTERNATIONALIZATION TARGETS

# PO files
set(pot_file ${CMAKE_PROJECT_NAME}.pot)
file(GLOB
	po_files
	*.po
)

if(GETTEXT_FOUND)
	set(GETTEXT_FOUND ON PARENT_SCOPE)
	include(gettext_create_translations)
	file(GLOB_RECURSE CPP_FILES
		RELATIVE "${CMAKE_SOURCE_DIR}/src"
		"${CMAKE_SOURCE_DIR}/src/*.c"
		"${CMAKE_SOURCE_DIR}/src/*.cpp"
		"${CMAKE_SOURCE_DIR}/src/*.h"
		"${CMAKE_SOURCE_DIR}/src/*.hpp"
	)
	add_custom_target(genpot
		COMMAND xgettext
			--language=C++
			--keyword=_ --keyword=N_ --indent
			--add-comments=TRANSLATORS:
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/TheTumultuousUnicornOfDarkness/CPU-X/issues
			--copyright-holder=TheTumultuousUnicornOfDarkness
			--output-dir=${CMAKE_CURRENT_BINARY_DIR}
			--output=source_c.pot
			--directory="${CMAKE_SOURCE_DIR}/src"
			--from-code="utf-8"
			${CPP_FILES}
		COMMAND xgettext
			--language=Glade
			--keyword=translatable --indent
			--add-comments
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/TheTumultuousUnicornOfDarkness/CPU-X/issues
			--copyright-holder=TheTumultuousUnicornOfDarkness
			--output-dir=${CMAKE_CURRENT_BINARY_DIR}
			--output=source_ui.pot
			--directory="${CMAKE_SOURCE_DIR}/data"
			--from-code="utf-8"
			"cpu-x-gtk-3.12.ui"
		COMMAND xgettext
			--language=Desktop
			--keyword --keyword=Comment --keyword=Keywords --indent
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/TheTumultuousUnicornOfDarkness/CPU-X/issues
			--copyright-holder=TheTumultuousUnicornOfDarkness
			--output-dir=${CMAKE_CURRENT_BINARY_DIR}
			--output=source_desktop.pot
			--directory="${CMAKE_SOURCE_DIR}/data"
			--from-code="utf-8"
			"io.github.thetumultuousunicornofdarkness.cpu-x.desktop.in"
		COMMAND	msgcat --indent --directory=${CMAKE_CURRENT_BINARY_DIR} source_c.pot source_ui.pot source_desktop.pot --output-file="${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		COMMAND sed --in-place "s/SOME DESCRIPTIVE TITLE./CPU-X translations template/" "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		COMMAND sed --in-place "s/\\(C\\) YEAR/© 2014-2025/"  "${CMAKE_CURRENT_SOURCE_DIR}/${pot_file}"
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
	)
	GETTEXT_CONVERT_TRANSLATIONS(${pot_file} ALL ${po_files})
else(GETTEXT_FOUND)
	set(GETTEXT_FOUND OFF PARENT_SCOPE)
endif(GETTEXT_FOUND)

=== src/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

### TIP: CMake commands orders
# - link_directories: The command will apply only to targets created after it is called.
# - add_executable: Adds an executable target called <name> to be built from the source files listed in the command invocation.
#                   (The source files can be omitted here if they are added later using target_sources().)
# - target_sources: The named <target> must have been created by a command such as add_executable().


### FIND REQUIRED LIBRAIRIES

# GTK3+
if(WITH_GTK)
	pkg_check_modules(GTK3 REQUIRED gtkmm-3.0>=3.12.0)
	if(GTK3_FOUND)
		include_directories(${GTK3_INCLUDE_DIRS})
		link_directories(${GTK3_LIBRARY_DIRS})
		add_definitions(${GTK3_CFLAGS_OTHER})
	endif(GTK3_FOUND)
endif(WITH_GTK)

# NCurses
if(WITH_NCURSES)
	set(CURSES_NEED_NCURSES TRUE)
	set(CURSES_NEED_WIDE TRUE)
	if(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
		set(CURSES_INCLUDE_PATH "/usr/local/include")
	endif(NOT CURSES_FOUND AND CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	find_package(Curses REQUIRED)
	if(CURSES_FOUND)
		include_directories(${CURSES_INCLUDE_DIRS})
	endif(CURSES_FOUND)
endif(WITH_NCURSES)

# Gettext
if(Intl_FOUND)
	include_directories(${Intl_INCLUDE_DIRS})
endif(Intl_FOUND)

# Libcpuid
if(WITH_LIBCPUID)
	pkg_check_modules(LIBCPUID REQUIRED libcpuid>=0.8.0)
	if(LIBCPUID_FOUND)
		include_directories(${LIBCPUID_INCLUDE_DIRS})
		link_directories(${LIBCPUID_LIBRARY_DIRS})
		add_definitions(${LIBCPUID_CFLAGS_OTHER})
		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
	endif(LIBCPUID_FOUND)
endif(WITH_LIBCPUID)

# Libpci
if(WITH_LIBPCI)
	pkg_check_modules(LIBPCI REQUIRED libpci)
	if(LIBPCI_FOUND)
		include_directories(${LIBPCI_INCLUDE_DIRS})
		link_directories(${LIBPCI_LIBRARY_DIRS})
		add_definitions(${LIBPCI_CFLAGS_OTHER})
	endif(LIBPCI_FOUND)
endif(WITH_LIBPCI)

# Libegl
if(WITH_LIBEGL)
	pkg_check_modules(LIBEGL REQUIRED egl>1.4)
	find_package(OpenGL REQUIRED COMPONENTS OpenGL EGL)
	if(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
		include_directories(${OPENGL_INCLUDE_DIRS} ${OPENGL_EGL_INCLUDE_DIRS})
		set(LIBOPENGL_LIBRARIES OpenGL::OpenGL OpenGL::EGL)
	endif(LIBEGL_FOUND AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
endif(WITH_LIBEGL)

# Vulkan
if(WITH_VULKAN)
	find_package(Vulkan REQUIRED)
	if(Vulkan_FOUND)
		include_directories(${Vulkan_INCLUDE_DIRS})
		set(LIBVUKLAN_LIBRARIES ${Vulkan_LIBRARIES})
	endif(Vulkan_FOUND)
endif(WITH_VULKAN)

# OpenCL
if(WITH_OPENCL)
	find_package(OpenCL REQUIRED)
	if(OpenCL_FOUND)
		include_directories(${OpenCL_INCLUDE_DIRS})
		set(LIBOPENCL_LIBRARIES ${OpenCL_LIBRARIES})
	endif(OpenCL_FOUND)
endif(WITH_OPENCL)

# Libprocps
set(LIBSYSTEM_LIBRARIES)
set(LIBSYSTEM 0)
set(LIBPROC2 -1)
if(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	pkg_check_modules(LIBPROC2 libproc2) # REQUIRED not present here to allow to fallback to libprocps
	if(LIBPROC2_FOUND)
		include_directories(${LIBPROC2_INCLUDE_DIRS})
		link_directories(${LIBPROC2_LIBRARY_DIRS})
		add_definitions(${LIBPROC2_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBPROC2_LIBRARIES})
		set(LIBSYSTEM 1)
		set(LIBPROC2 1)
	else()
		pkg_check_modules(LIBPROCPS REQUIRED libprocps)
		set(LIBPROC2 0)
	endif()
	if(LIBPROCPS_FOUND)
		include_directories(${LIBPROCPS_INCLUDE_DIRS})
		link_directories(${LIBPROCPS_LIBRARY_DIRS})
		add_definitions(${LIBPROCPS_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBPROCPS_LIBRARIES})
		set(LIBSYSTEM 1)
	endif(LIBPROCPS_FOUND)
endif(WITH_LIBPROCPS AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)

# Libstatgrab
if(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))
	pkg_check_modules(LIBSTATGRAB REQUIRED libstatgrab)
	if(LIBSTATGRAB_FOUND)
		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
		add_definitions(${LIBSTATGRAB_CFLAGS_OTHER})
		set(LIBSYSTEM_LIBRARIES ${LIBSTATGRAB_LIBRARIES})
		set(LIBSYSTEM 2)
	endif(LIBSTATGRAB_FOUND)
endif(WITH_LIBSTATGRAB AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR FORCE_LIBSTATGRAB))

# Dmidecode
if(WITH_DMIDECODE)
	add_subdirectory(core/dmidecode)
	include_directories(core/dmidecode)
	set(DMIDECODE_LIBRARIES "dmidecode")
endif(WITH_DMIDECODE)

# Bandwidth
if(CPU_ISA_X86 AND WITH_BANDWIDTH)
	add_subdirectory(core/bandwidth)
	if(BANDWIDTH_FOUND)
		include_directories(core/bandwidth)
		set(BANDWIDTH_LIBRARIES "bandwidth")
	endif(BANDWIDTH_FOUND)
endif(CPU_ISA_X86 AND WITH_BANDWIDTH)


### FINAL CONFIG

message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}${GIT_REVISION} configuration (${CMAKE_SYSTEM_PROCESSOR}) **${ColourReset}")

# UI libraries
print_config("GTK"                 "${GTK3_VERSION}"            WITH_GTK)
print_config("NCURSES"             "${NCURSES_VERSION}"         WITH_NCURSES)

# Other libraries
print_config("GETTEXT"             "${GETTEXT_VERSION_STRING}"  WITH_GETTEXT)
print_config("LIBCPUID"            "${LIBCPUID_VERSION}"        WITH_LIBCPUID)
print_config("LIBPCI"              "${LIBPCI_VERSION}"          WITH_LIBPCI)
print_config("LIBEGL"              "${LIBEGL_VERSION}"          WITH_LIBEGL)
print_config("VULKAN"              "${Vulkan_VERSION}"          WITH_VULKAN)
print_config("OPENCL"              "${OpenCL_VERSION_STRING}"   WITH_OPENCL)
if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	if(${LIBPROC2} EQUAL 1)
		print_config("LIBPROC2"    "${LIBPROC2_VERSION}"        WITH_LIBPROCPS)
	else()
		print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"       WITH_LIBPROCPS)
	endif()
else()
	print_config("LIBSTATGRAB"     "${LIBSTATGRAB_VERSION}"     WITH_LIBSTATGRAB)
endif()

# Subprojects
print_config("DMIDECODE"           "${DMIDECODE_VERSION}"       WITH_DMIDECODE)
print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"       WITH_BANDWIDTH)


### BINARIES

# Executables
add_executable(${APP_EXEC}
	core/benchmarks.cpp
	core/core.cpp
	core/core.hpp
	core/internal.hpp
	daemon/client.cpp
	daemon/client.hpp
	daemon/daemon.h
	data.cpp
	data.hpp
	logger.cpp
	logger.hpp
	main.cpp
	options.cpp
	options.hpp
	util.cpp
	util.hpp
)

add_executable(${DAEMON_EXEC}
	daemon/server.cpp
	daemon/server.hpp
	daemon/daemon.h
	data.cpp
	data.hpp
	logger.cpp
	logger.hpp
	options.cpp
	options.hpp
	util.cpp
	util.hpp
)


# Additional source files
# GTK3+
if(WITH_GTK AND GTK3_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		ui/gtk.cpp
		ui/gtk.hpp
	)
endif(WITH_GTK AND GTK3_FOUND)

# NCurses
if(WITH_NCURSES AND NCURSES_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		ui/ncurses.cpp
		ui/ncurses.hpp
	)
endif(WITH_NCURSES AND NCURSES_FOUND)

# Libcpuid
if(WITH_LIBCPUID AND LIBCPUID_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libcpuid.cpp
		core/databases.h
	)
	target_sources(${DAEMON_EXEC}
		PRIVATE
		core/libcpuid.cpp
		core/databases.h
	)
endif(WITH_LIBCPUID AND LIBCPUID_FOUND)

# Libpci
if(WITH_LIBPCI AND LIBPCI_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libpci.cpp
	)
endif(WITH_LIBPCI AND LIBPCI_FOUND)

# Libegl
if(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libopengl.cpp
	)
endif(WITH_LIBEGL AND OpenGL_OpenGL_FOUND AND OpenGL_EGL_FOUND)

# Vulkan
if(WITH_VULKAN AND Vulkan_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libvulkan.cpp
	)
endif(WITH_VULKAN AND Vulkan_FOUND)

# OpenCL
if(WITH_OPENCL AND OpenCL_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libopencl.cpp
		core/opencl_ext.h
	)
endif(WITH_OPENCL AND OpenCL_FOUND)

# Libsystem (libproc2/libprocps/libstatgrab)
if(${LIBSYSTEM} GREATER 0)
	target_sources(${APP_EXEC}
		PRIVATE
		core/libsystem.cpp
	)
endif(${LIBSYSTEM} GREATER 0)

# Dmidecode
if(WITH_DMIDECODE)
	target_sources(${APP_EXEC}
		PRIVATE
		core/dmidecode/libdmidecode.cpp
		core/dmidecode/libdmidecode.h
	)
	target_sources(${DAEMON_EXEC}
		PRIVATE
		core/dmidecode/libdmidecode.cpp
		core/dmidecode/libdmidecode.h
	)
endif(WITH_DMIDECODE)

# Bandwidth
if(WITH_BANDWIDTH AND BANDWIDTH_FOUND)
	target_sources(${APP_EXEC}
		PRIVATE
		core/bandwidth/libbandwidth.cpp
		core/bandwidth/libbandwidth.h
	)
endif(WITH_BANDWIDTH AND BANDWIDTH_FOUND)


### DEFINITIONS & LINK

# Libsystem extra-definitions
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 1) # When Libprocps is used
	add_definitions(-DHAS_LIBSTATGRAB=0 -DLIBSTATGRAB_VERSION=NULL)
	if(${LIBPROC2} EQUAL 1)
		add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
	else(${LIBPROC2} EQUAL 0)
		add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	endif()
endif()
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 2) # When Libstatgrab is used
	add_definitions(-DHAS_LIBPROC2=0  -DLIBPROC2_VERSION=NULL)
	add_definitions(-DHAS_LIBPROCPS=0 -DLIBPROCPS_VERSION=NULL)
endif()

# ARM CPUs workarounds
if(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(OTHER_LIBRARIES "-latomic")
endif(CPU_ISA_ARM AND CMAKE_SYSTEM_NAME MATCHES "Linux")

# AppImage workarounds
if(APPIMAGE)
	add_definitions(-DAPPIMAGE
		-DDAEMON_TMP_EXEC="/tmp/${DAEMON_EXEC}"
	)
endif(APPIMAGE)

# Flatpak workarounds
if(FLATPAK)
	add_definitions(-DFLATPAK)
	set(DAEMON_SOCKET cpu-x.sock)
	if(LIBCPUID_FOUND)
		# flatpak-spawn command will not be able to find libcpuid.so when starting cpu-x-daemon
		set(LIBCPUID_LIBRARIES "-l:libcpuid.a")
	endif(LIBCPUID_FOUND)
endif(FLATPAK)

# Various definitions
add_definitions(-DPRGVER="${PROJECT_VERSION}"
	-DGITREV="${GIT_REVISION}"
	-DSYSTEM_NAME="${CMAKE_SYSTEM_NAME}"
	-DSYSTEM_PROCESSOR="${CMAKE_SYSTEM_PROCESSOR}"
	-DC_COMPILER_ID="${CMAKE_C_COMPILER_ID}"
	-DHAS_LIBSYSTEM=${LIBSYSTEM}
	-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}"
	-DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
	-DCPUX_DATA_DIRECTORY="${CPU_X_DATA_DIRECTORY}"
	-DTERMINFODIR="/lib/terminfo"
	-DDAEMON_EXEC="${DAEMON_EXEC}"
	-DDAEMON_PATH="${DAEMON_PATH}"
	-DSOCKET_NAME="${DAEMON_SOCKET}"
)

# Link libraries
target_link_libraries(${APP_EXEC}
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	${Backtrace_LIBRARIES}
	std::filesystem

	${GTK3_LIBRARIES}
	${CURSES_LIBRARIES}
	${LIBCPUID_LIBRARIES}
	${LIBPCI_LIBRARIES}
	${LIBOPENGL_LIBRARIES}
	${LIBVUKLAN_LIBRARIES}
	${LIBOPENCL_LIBRARIES}
	${LIBSYSTEM_LIBRARIES}
	${DMIDECODE_LIBRARIES}
	${BANDWIDTH_LIBRARIES}
	${OTHER_LIBRARIES}
)

target_link_libraries(${DAEMON_EXEC}
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	std::filesystem

	${LIBCPUID_LIBRARIES}
	${DMIDECODE_LIBRARIES}
)


### INSTALLATION

install(TARGETS ${APP_EXEC}    DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}/)
install(TARGETS ${DAEMON_EXEC} DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}/)

=== data/completions/CMakeLists.txt ===
project(completions
	LANGUAGES NONE
)

install(FILES
	bash
	DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/bash-completion/completions/
	RENAME ${CMAKE_PROJECT_NAME}
)

install(FILES
	fish
	DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/fish/vendor_completions.d/
	RENAME ${CMAKE_PROJECT_NAME}.fish
)

install(FILES
	zsh
	DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/zsh/site-functions/
	RENAME _${CMAKE_PROJECT_NAME}
)

=== data/icons/CMakeLists.txt ===
project(icons
	LANGUAGES NONE
)


# Icons
file(GLOB
	icons
	CPU-X_*x*.png
)

foreach(icon ${icons})
	get_filename_component(filename ${icon} NAME_WE)
	string(REGEX REPLACE "CPU-X_" "" size "${filename}")
	install(FILES
		${icon}
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${size}/apps/
		RENAME io.github.thetumultuousunicornofdarkness.cpu-x.png
	)
endforeach()

install(FILES
	CPU-X_original.png
	DESTINATION ${CPU_X_DATA_DIRECTORY}/
	RENAME CPU-X.png
)

=== data/logos/CMakeLists.txt ===
project(logos
	LANGUAGES NONE
)


# Logos
file(GLOB
	logos
	*.png
)

install(FILES
	${logos}
	DESTINATION ${CPU_X_DATA_DIRECTORY}/
)

=== src/core/bandwidth/CMakeLists.txt ===
project(bandwidth
	VERSION "1.14.10"
	LANGUAGES C
)

# Config (bandwidth)
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-sign-compare -Wno-type-limits -Wno-strict-prototypes -Wno-unused-parameter")

if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
	set(NASM_FLAGS_DEBUG "-gdwarf")
endif(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# Build (bandwidth)
check_language(ASM_NASM)
if(CMAKE_ASM_NASM_COMPILER)
	enable_language(ASM_NASM)
	set(BANDWIDTH_FOUND ON PARENT_SCOPE)
	message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}, object format ${CMAKE_ASM_NASM_OBJECT_FORMAT}")

	# NASM routines build
	if(CMAKE_ASM_NASM_OBJECT_FORMAT MATCHES "elf64" OR CMAKE_ASM_NASM_OBJECT_FORMAT MATCHES "elfx32")
		set(ROUTINES "routines-x86-64bit")
		set(UTILITY  "utility-x86-64bit")
	else()
		set(ROUTINES "routines-x86-32bit")
		set(UTILITY  "utility-x86-32bit")
	endif()
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
		COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f ${CMAKE_ASM_NASM_OBJECT_FORMAT} ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${UTILITY}.o
		COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f ${CMAKE_ASM_NASM_OBJECT_FORMAT} ${UTILITY}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${UTILITY}.o
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/OOC
	)

	if(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=1)
	else(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=0)
	endif(LIBCPUID_FOUND AND WITH_LIBCPUID)

	file(GLOB OOC_FILES
		"OOC/*.c"
		"OOC/*.h"
	)
	add_library(bandwidth
		STATIC
		${OOC_FILES}
		main.c
		libbandwidth.h
		Testing.c
		TestingX86.c
		${ROUTINES}.o
		${UTILITY}.o
	)

	target_link_libraries(bandwidth)
	set(BANDWIDTH_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

else(CMAKE_ASM_NASM_COMPILER)
	set(BANDWIDTH_FOUND OFF PARENT_SCOPE)
endif(CMAKE_ASM_NASM_COMPILER)

=== src/core/dmidecode/CMakeLists.txt ===
project(dmidecode
	VERSION "3.6.20250725"
	LANGUAGES C
)

# Config (dmidecode)
set(CMAKE_C_FLAGS       "${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Wno-shift-count-overflow")
message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")

# Build (dmidecode)
add_definitions(-DVERSION="${PROJECT_VERSION}")
add_library(dmidecode
	STATIC
	types.h
	util.c
	util.h
	dmiopt.h
	dmiopt.c
	dmioem.c
	dmioem.h
	dmidecode.c
	dmidecode.h
	dmioutput.c
	dmioutput.h
)

target_link_libraries(dmidecode)
set(DMIDECODE_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

=== debian/changelog ===
cpu-x (5.4.0-0.1) unstable; urgency=medium

  * NMU
  * rules-requires-root now defaults to no
  * new upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 28 Aug 2025 10:44:33 +0100

=== debian/control ===
Source: cpu-x
Section: x11
Priority: optional
Maintainer: Martin Wimpress <code@wimpress.io>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.12),
               gawk,
               gettext,
               libcpuid-dev (>= 0.8.0+repack1-0.3),
               libgtkmm-3.0-dev (>= 3.12),
               libcurl4-gnutls-dev,
               libegl-dev (>= 1.5),
               libjson-c-dev,
               libncurses-dev,
               libpci-dev (>= 3.13),
               libproc2-dev,
               libstatgrab-dev,
               libvulkan-dev,
	       vulkan-validationlayers,
	       glslang-tools,
	       glslc,
               opencl-headers,
	       ocl-icd-opencl-dev,
               nasm,
               pkgconf,
               procps,
Standards-Version: 4.7.2
Homepage: https://github.com/X0rg/CPU-X
Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
Vcs-Browser: https://salsa.debian.org/debian/cpu-x

Package: cpu-x
Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
Description: Tool that gathers information on CPU, motherboard and more
 CPU-X is similar to CPU-Z (for MS Windows). It can be used in graphical
 mode by using GTK or in text-based mode by using NCurses. A dump mode is
 present from the command line.

=== debian/rules ===
#!/usr/bin/make -f

NULL=

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS := $(shell dpkg-architecture --equal x32 && echo -DWITH_BANDWIDTH=0)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://github.com/X0rg/CPU-X/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
